// Plastic calibration class
// 

#ifndef _TARTCALIBPLASTIC_H_
#define _TARTCALIBPLASTIC_H_

#include <TClonesArray.h>
#include <TString.h>

class TArtRawEventObject;
class TArtRawSegmentObject;
class TArtPlasticPara;
class TArtBigRIPSParameters;
class TArtPlastic;
class TArtStoreManager;

class TArtCalibPlastic  {

 public:

  TArtCalibPlastic();
  virtual ~TArtCalibPlastic();

  void Initialize();
  void LoadData();
  void LoadData(TArtRawSegmentObject *);
  void ClearData();
  void ReconstructData();
  void ReconstructData(TArtPlastic *pla, TArtPlasticPara *para);

  bool IsReconstructed(){ return fReconstructed; }

  // function to access data container
  TClonesArray    * GetPlasticArray(){return fPlasticArray;}
  Int_t             GetNumPlastic();
  TArtPlastic     * GetPlastic(int i);
  TArtPlasticPara * GetPlasticPara(int i);
  // looking for ic whose id is i. return NULL in the case of fail to find.
  TArtPlastic     * FindPlastic(int i);
  // looking for ic whose name is n. return NULL in the case of fail to find.
  TArtPlastic     * FindPlastic(TString *n);
  TArtPlastic     * FindPlastic(char *n);

 private:

  bool fDataLoaded;
  bool fReconstructed;

  TClonesArray       * fPlasticArray;
  // temporal buffer for pointer for plastic parameter
  std::vector <TArtPlasticPara*> fPlasticParaArray;

  TArtBigRIPSParameters * setup;
  TArtStoreManager * sman;

  ClassDef(TArtCalibPlastic,1);

};

#endif
