// tof reconstruction class
// 

#ifndef _TARTRECOTOF_H_
#define _TARTRECOTOF_H_

#include <TNamed.h>
#include <TClonesArray.h>

class TArtBigRIPSParameters;
class TArtPlastic;
class TArtTOF;
class TArtStoreManager;

class TArtRecoTOF  {

 public:

  TArtRecoTOF();
  virtual ~TArtRecoTOF();

  void Initialize();
  void ClearData();
  void ReconstructData();

  bool IsReconstructed(){ return fReconstructed; }
  TArtTOF * DefineNewTOF(char *uplname, char *dplname, Double_t offset=0);

  // function to access data container
  TClonesArray    * GetTOFArray(){return fTOFArray;}
  Int_t             GetNumTOF();
  // get i-th object in array
  TArtTOF  * GetTOF(int i);
  // looking for fpl object whose forward fpl-number is f_fpl and backward fpl-number is b_fpl. return NULL in the case of fail to find.
  TArtTOF  * FindTOF(char *uplname, char *dplname);

 private:

  bool fReconstructed;

  TClonesArray       * fTOFArray;
  TArtBigRIPSParameters * setup;
  TArtStoreManager * sman;

  ClassDef(TArtRecoTOF,1);

};

#endif
